/*
 * WShape.h
 *
 *  Created on: 25.06.2012
 *      Author: Stoycho Stefanov
 */

#ifndef IMCWSHAPE_H_
#define IMCWSHAPE_H_

#include "Widget.h"
#include "Shape.h"
#include "Defs.h"

class PanelPage;
class Wt::WInPlaceEdit;
class Wt::WString;
class Wt::WIntValidator;

class WShape: public Widget
{
public:
	WShape(PanelPage*);
	virtual ~WShape();
	void update(void);
	void updateValue(void){};
	void setShape(Defs::ShapeStyle shape);
	void setLineType(Defs::LineType type);
	std::vector< std::vector<Wt::WWidget* > > getProperties(Defs::PropertiesGroup propGr);
	void saveProperties(boost::property_tree::ptree&){ };
	void setFrameWidth(int i);
private:
	Shape* face_;
	void setProperty(boost::property_tree::ptree::const_iterator){};
	Wt::WIntValidator* widthValidator_; 	// int >= 0 common for label and value
	friend class Shape;
};

#endif /* IMCWSHAPE_H_ */
